variables:
  CI_REGISTRY_USER: 8796230550
  CI_REGISTRY_IMAGE: 8796230550/hotel-service
  ARTIFACT_NAME: hotel-service-v$CI_PIPELINE_IID.jar
  
stages:
  - .pre
  - build
  - deploy

maven-build:
  image: maven:3-jdk-8
  stage: .pre
  script:
    - mvn clean install package
    - mv ./target/hotel-service-0.0.1-SNAPSHOT.jar ./target/$ARTIFACT_NAME
  artifacts:
    paths:
      - ./target/

build image:
  image: docker:latest
  stage: build
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD"
  script:
    - docker build -t "$CI_REGISTRY_IMAGE:$CI_PIPELINE_IID" .
    - docker push "$CI_REGISTRY_IMAGE:$CI_PIPELINE_IID"

deploy:
  stage: deploy
  before_script:
    - eval `ssh-agent`
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - ssh-keyscan -H $EC2_HOST >> ~/.ssh/known_hosts
  script:
    - ssh ec2-user@$EC2_HOST sudo docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
    - ssh ec2-user@$EC2_HOST sudo docker pull $CI_REGISTRY_IMAGE:$CI_PIPELINE_IID
    - (if [ "$(ssh ec2-user@$EC2_HOST sudo docker ps -f "publish=80" -q)" ]; then ssh ec2-user@$EC2_HOST sudo docker stop $(ssh ec2-user@$EC2_HOST sudo docker ps -f "publish=80" -q); fi)
    - ssh ec2-user@$EC2_HOST sudo docker run -d -p 80:80 $CI_REGISTRY_IMAGE:$CI_PIPELINE_IID
    - ssh ec2-user@$EC2_HOST sudo docker logout
  after_script:
    - kill $SSH_AGENT_PID
    - ssh ec2-user@$EC2_HOST sudo docker logout
